// ---------------------------------------------------------------------------
// This file has been generated partially by the Web Dynpro Code Generator.
// MODIFY CODE ONLY IN SECTIONS ENCLOSED BY @@begin AND @@end.
// ALL OTHER CHANGES WILL BE LOST IF THE FILE IS REGENERATED.
// ---------------------------------------------------------------------------
package com.sap.tc.webdynpro.tutorial.popup;

// 
// IMPORTANT NOTE: 
// _ALL_ IMPORT STATEMENTS MUST BE PLACED IN THE FOLLOWING SECTION ENCLOSED
// BY @@begin imports AND @@end. FURTHERMORE, THIS SECTION MUST ALWAYS CONTAIN
// AT LEAST ONE IMPORT STATEMENT (E.G. THAT FOR IPrivateEmailView).
// OTHERWISE, USING THE ECLIPSE FUNCTION "Organize Imports" FOLLOWED BY
// A WEB DYNPRO CODE GENERATION (E.G. PROJECT BUILD) WILL RESULT IN THE LOSS
// OF IMPORT STATEMENTS.
//
//@@begin imports
import com.sap.tc.webdynpro.progmodel.api.IWDMessageManager;
import com.sap.tc.webdynpro.progmodel.repository.IWDEventHandlerInfo;
import com.sap.tc.webdynpro.progmodel.repository.IWDWindowInfo;
import com.sap.tc.webdynpro.services.session.api.IWDConfirmationDialog;
import com.sap.tc.webdynpro.services.session.api.IWDWindow;
import com.sap.tc.webdynpro.tutorial.popup.wdp.IPrivateEmailView;
import com.sap.tc.webdynro.tutorial.popup.model.Request_IEmailService_sendMail;
//@@end

//@@begin documentation
//@@end

public class EmailView
{
  /**
   * Logging location.
   */
  private static final com.sap.tc.logging.Location logger = 
    com.sap.tc.logging.Location.getLocation(EmailView.class);

  static 
  {
    //@@begin id
    String id = "$Id$";
    //@@end
    com.sap.tc.logging.Location.getLocation("ID.com.sap.tc.webdynpro").infoT(id);
  }

  /**
   * Private access to the generated Web Dynpro counterpart 
   * for this controller class.  </p>
   *
   * Use <code>wdThis</code> to gain typed access to the context,
   * to trigger navigation via outbound plugs, to get and enable/disable
   * actions, fire declared events, and access used controllers and/or 
   * component usages.
   *
   * @see com.sap.tc.webdynpro.tutorial.popup.wdp.IPrivateEmailView for more details
   */
  private final IPrivateEmailView wdThis;

  /**
   * Root node of this controller's context. </p>
   *
   * Provides typed access not only to the elements of the root node 
   * but also to all nodes in the context (methods node<i>XYZ</i>()) 
   * and their currently selected element (methods current<i>XYZ</i>Element()). 
   * It also facilitates the creation of new elements for all nodes 
   * (methods create<i>XYZ</i>Element()). </p>
   *
   * @see com.sap.tc.webdynpro.tutorial.popup.wdp.IPrivateEmailView.IContextNode for more details.
   */
  private final IPrivateEmailView.IContextNode wdContext;

  /**
   * A shortcut for <code>wdThis.wdGetAPI()</code>. </p>
   * 
   * Represents the generic API of the generic Web Dynpro counterpart 
   * for this controller. </p>
   */
  private final com.sap.tc.webdynpro.progmodel.api.IWDViewController wdControllerAPI;
  
  /**
   * A shortcut for <code>wdThis.wdGetAPI().getComponent()</code>. </p>
   * 
   * Represents the generic API of the Web Dynpro component this controller 
   * belongs to. Can be used to access the message manager, the window manager,
   * to add/remove event handlers and so on. </p>
   */
  private final com.sap.tc.webdynpro.progmodel.api.IWDComponent wdComponentAPI;
  
  public EmailView(IPrivateEmailView wdThis)
  {
    this.wdThis = wdThis;
    this.wdContext = wdThis.wdGetContext();
    this.wdControllerAPI = wdThis.wdGetAPI();
    this.wdComponentAPI = wdThis.wdGetAPI().getComponent();
  }

  //@@begin javadoc:wdDoInit()
  /** Hook method called to initialize controller. */
  //@@end
  public void wdDoInit()
  {
    //@@begin wdDoInit()
	//	create a new instance of the Web Service ModelClass  
	Request_IEmailService_sendMail req = new Request_IEmailService_sendMail();   
    
	// bind new instance of the Web Service ModelClass to the independent Model Node
	wdContext.nodeWebServiceEmail().bind(req);

    //@@end
  }

  //@@begin javadoc:wdDoExit()
  /** Hook method called to clean up controller. */
  //@@end
  public void wdDoExit()
  {
    //@@begin wdDoExit()
    //@@end
  }

  //@@begin javadoc:wdDoModifyView
  /**
   * Hook method called to modify a view just before rendering.
   * This method conceptually belongs to the view itself, not to the
   * controller (cf. MVC pattern).
   * It is made static to discourage a way of programming that
   * routinely stores references to UI elements in instance fields
   * for access by the view controller's event handlers, and so on.
   * The Web Dynpro programming model recommends that UI elements can
   * only be accessed by code executed within the call to this hook method.
   *
   * @param wdThis Generated private interface of the view's controller, as
   *        provided by Web Dynpro. Provides access to the view controller's
   *        outgoing controller usages, etc.
   * @param wdContext Generated interface of the view's context, as provided
   *        by Web Dynpro. Provides access to the view's data.
   * @param view The view's generic API, as provided by Web Dynpro.
   *        Provides access to UI elements.
   * @param firstTime Indicates whether the hook is called for the first time
   *        during the lifetime of the view.
   */
  //@@end
  public static void wdDoModifyView(IPrivateEmailView wdThis, IPrivateEmailView.IContextNode wdContext, com.sap.tc.webdynpro.progmodel.api.IWDView view, boolean firstTime)
  {
    //@@begin wdDoModifyView
    //@@end
  }

  //@@begin javadoc:onActionSendMail(ServerEvent)
  /** Declared validating event handler. */
  //@@end
  public void onActionSendMail(com.sap.tc.webdynpro.progmodel.api.IWDCustomEvent wdEvent )
  {
    //@@begin onActionSendMail(ServerEvent)
//	@@begin onActionSendMail(ServerEvent)
	  IWDMessageManager msgMgr = 
	  	wdThis.wdGetAPI().getComponent().getMessageManager();
	
	  try {
		// call Email Web Service 
		wdContext.currentWebServiceEmailElement().modelObject().execute();
		wdContext.nodeResponse().invalidate(); 
          
		int result = wdContext.currentResponseElement().getResult();  
		String msg = "successfully sent (Email Web Service returned " + Integer.toString(result) + ")! ";
      	msgMgr.reportSuccess(msg);
		String dialogText; 
		if (result== 0) {
			dialogText = "The email was "  + msg;
		} 
		else {
			dialogText = "The email was not " + msg;
		}
		
		//Todo: Add code to trigger confirmation dialog popup here.

	  } catch(Exception ex) {
		msgMgr.reportException(ex.getLocalizedMessage(),true);  
	  }

    //@@end
  }

  //@@begin javadoc:onActionShowAddressbookPopup(ServerEvent)
  /** Declared validating event handler. */
  //@@end
  public void onActionShowAddressbookPopup(com.sap.tc.webdynpro.progmodel.api.IWDCustomEvent wdEvent )
  {
    //@@begin onActionShowAddressbookPopup(ServerEvent)
    //Todo: Add code here to trigger the AddressbookWindow popup.
    //@@end
  }

  //@@begin javadoc:onActionShowGoogleWindow(ServerEvent)
  /** Declared validating event handler. */
  //@@end
  public void onActionShowGoogleWindow(com.sap.tc.webdynpro.progmodel.api.IWDCustomEvent wdEvent )
  {
    //@@begin onActionShowGoogleWindow(ServerEvent)
	//Todo: Add code to trigger external Google window here.
    //@@end
  }

  //@@begin javadoc:handleAddressSelectedEvent(ServerEvent)
  /** Declared validating event handler. */
  //@@end
  public void handleAddressSelectedEvent(com.sap.tc.webdynpro.progmodel.api.IWDCustomEvent wdEvent )
  {
    //@@begin handleAddressSelectedEvent(ServerEvent)
	//Todo: Add code here to get selected email address and destroy the popup window.
    //@@end
  }

  //@@begin javadoc:ok(ServerEvent)
  /** Declared validating event handler. */
  //@@end
  public void ok(com.sap.tc.webdynpro.progmodel.api.IWDCustomEvent wdEvent )
  {
    //@@begin ok(ServerEvent)
    //@@end
  }

  //@@begin javadoc:newEmail(ServerEvent)
  /** Declared validating event handler. */
  //@@end
  public void newEmail(com.sap.tc.webdynpro.progmodel.api.IWDCustomEvent wdEvent )
  {
    //@@begin newEmail(ServerEvent)
	wdContext.currentWebServiceEmailElement().setToAddress("");
	wdContext.currentWebServiceEmailElement().setFromAddress("");
	wdContext.currentWebServiceEmailElement().setMsgBody("");
	wdContext.currentWebServiceEmailElement().setASubject("");
    //@@end
  }

  //@@begin javadoc:cancel(ServerEvent)
  /** Declared validating event handler. */
  //@@end
  public void cancel(com.sap.tc.webdynpro.progmodel.api.IWDCustomEvent wdEvent )
  {
    //@@begin cancel(ServerEvent)
    //@@end
  }

  /*
   * The following code section can be used for any Java code that is 
   * not to be visible to other controllers/views or that contains constructs
   * currently not supported directly by Web Dynpro (such as inner classes or
   * member variables etc.). </p>
   *
   * Note: The content of this section is in no way managed/controlled
   * by the Web Dynpro Designtime or the Web Dynpro Runtime. 
   */
  //@@begin others
  IWDWindow localWindow = null;
  //@@end
}
