package com.sap.tc.webdynro.tutorial.popup.model.proxies;

// Import libraries
import javax.xml.rpc.holders.*;
import java.rmi.RemoteException;
import javax.xml.rpc.encoding.*;
import javax.xml.namespace.QName;
import com.sap.engine.services.webservices.jaxrpc.wsdl2java.ServiceParam;
import com.sap.engine.services.webservices.jaxrpc.wsdl2java.PropertyContext;

public class IEmailServicebindingStub extends com.sap.engine.services.webservices.jaxrpc.wsdl2java.BaseGeneratedStub implements com.sap.tc.webdynro.tutorial.popup.model.proxies.IEmailService {

  // Proxy variables
  private com.sap.engine.services.webservices.jaxrpc.encoding.TypeMappingRegistryImpl typeRegistry;

  public IEmailServicebindingStub() {
    super();
    super._setEndpoint("http://webservices.matlus.com/scripts/emailwebservice.dll/soap/IEmailservice");
    this.transportBinding = new com.sap.engine.services.webservices.jaxrpc.wsdl2java.soapbinding.MimeHttpBinding();
    try {
      this.typeRegistry = new com.sap.engine.services.webservices.jaxrpc.encoding.TypeMappingRegistryImpl();
    } catch (java.lang.Exception e) {
      throw new RuntimeException("Can not load type mapping information !");
    }
    this.featureConfiguration.setProperty("typeMapping",this.typeRegistry.getDefaultTypeMapping());
    this.localProtocols.put("SendMail",new com.sap.engine.services.webservices.jaxrpc.wsdl2java.ProtocolList());
    this.localFeatures.put("SendMail",new PropertyContext());
  }

  public int sendMail(java.lang.String toAddress, java.lang.String fromAddress, java.lang.String aSubject, java.lang.String msgBody) throws java.rmi.RemoteException {
    try {
      // Operation input params initialization
      this.inputParams = new ServiceParam[4];
      this.inputParams[0] = new ServiceParam();
      this.inputParams[0].schemaName = new QName("http://www.w3.org/2001/XMLSchema","string");
      this.inputParams[0].name = "ToAddress";
      this.inputParams[0].contentClass = java.lang.String.class;
      this.inputParams[0].content = toAddress;
      this.inputParams[1] = new ServiceParam();
      this.inputParams[1].schemaName = new QName("http://www.w3.org/2001/XMLSchema","string");
      this.inputParams[1].name = "FromAddress";
      this.inputParams[1].contentClass = java.lang.String.class;
      this.inputParams[1].content = fromAddress;
      this.inputParams[2] = new ServiceParam();
      this.inputParams[2].schemaName = new QName("http://www.w3.org/2001/XMLSchema","string");
      this.inputParams[2].name = "ASubject";
      this.inputParams[2].contentClass = java.lang.String.class;
      this.inputParams[2].content = aSubject;
      this.inputParams[3] = new ServiceParam();
      this.inputParams[3].schemaName = new QName("http://www.w3.org/2001/XMLSchema","string");
      this.inputParams[3].name = "MsgBody";
      this.inputParams[3].contentClass = java.lang.String.class;
      this.inputParams[3].content = msgBody;
      // Operation output params initialization
      this.outputParams = new ServiceParam[1];
      this.outputParams[0] = new ServiceParam();
      this.outputParams[0].schemaName = new QName("http://www.w3.org/2001/XMLSchema","int");
      this.outputParams[0].name = "return";
      this.outputParams[0].contentClass = int.class;
      // Operation faults initialization
      this.faultParams = new ServiceParam[0];
      int returnTemp;
      this.transportBinding.setTypeMappingRegistry(this.typeRegistry);
      this.transportBinding.startOperation(this.inputParams,this.outputParams,this.faultParams);
      // Binding Context initialization
      this.bindingConfiguration.clear();
      bindingConfiguration.setProperty("soapAction","urn:EmailIPortTypeInft-IEmailService#SendMail");
      bindingConfiguration.setProperty("style","rpc");
      bindingConfiguration.setProperty("transport","http://schemas.xmlsoap.org/soap/http");
      PropertyContext bindingConfigurationX;
      bindingConfigurationX = bindingConfiguration.getSubContext("output");
      bindingConfigurationX.setProperty("operationName","SendMail");
      bindingConfigurationX.setProperty("use","encoded");
      bindingConfigurationX.setProperty("encodingStyle","http://schemas.xmlsoap.org/soap/encoding/");
      bindingConfigurationX.setProperty("namespace","urn:EmailIPortTypeInft-IEmailService");
      bindingConfigurationX = bindingConfiguration.getSubContext("input");
      bindingConfigurationX.setProperty("operationName","SendMail");
      bindingConfigurationX.setProperty("use","encoded");
      bindingConfigurationX.setProperty("encodingStyle","http://schemas.xmlsoap.org/soap/encoding/");
      bindingConfigurationX.setProperty("namespace","urn:EmailIPortTypeInft-IEmailService");
      super._fillEndpoint(bindingConfiguration);
      _buildOperationContext("SendMail",this.transportBinding);
      this.transportBinding.call(this.stubConfiguration,this.globalProtocols,_getOperationProtocols("SendMail"));
      returnTemp = ((java.lang.Integer) this.outputParams[0].content).intValue();
      return returnTemp;
    } catch (javax.xml.rpc.soap.SOAPFaultException e) {
      throw e;
    } catch (java.lang.Exception e) {
      throw new RemoteException("Service call exception",e);
    }
  }


}
